Module javafx.graphics
Package javafx.scene.shape

# Class CubicCurve

java.lang.Object
javafx.scene.Node
javafx.scene.shape.Shape
javafx.scene.shape.CubicCurve

All Implemented Interfaces:
  `Styleable`, `EventTarget`

public class CubicCurve extends Shape

The `CubiCurve` class defines a cubic Bézier parametric curve segment in (x,y) coordinate space. Drawing a curve that intersects both the specified coordinates `(startX, startY)` and `(endX, enfY)`, using the specified points `(controlX1, controlY1)` and `(controlX2, controlY2)` as Bézier control points. Example:

    import javafx.scene.shape.*;

    CubicCurve cubic = new CubicCurve();
    cubic.setStartX(0.0f);
    cubic.setStartY(50.0f);
    cubic.setControlX1(25.0f);
    cubic.setControlY1(0.0f);
    cubic.setControlX2(75.0f);
    cubic.setControlY2(100.0f);
    cubic.setEndX(100.0f);
    cubic.setEndY(50.0f);
    }

Since:
  JavaFX 2.0

- ## Property Summary

  Properties
  Type
  Property
  Description
  `final DoubleProperty`
  `controlX1`
  Defines the X coordinate of the first control point of the cubic curve segment.
  `final DoubleProperty`
  `controlX2`
  Defines the X coordinate of the second control point of the cubic curve segment.
  `final DoubleProperty`
  `controlY1`
  Defines the Y coordinate of the first control point of the cubic curve segment.
  `final DoubleProperty`
  `controlY2`
  Defines the Y coordinate of the second control point of the cubic curve segment.
  `final DoubleProperty`
  `endX`
  Defines the X coordinate of the end point of the cubic curve segment.
  `final DoubleProperty`
  `endY`
  Defines the Y coordinate of the end point of the cubic curve segment.
  `final DoubleProperty`
  `startX`
  Defines the X coordinate of the start point of the cubic curve segment.
  `final DoubleProperty`
  `startY`
  Defines the Y coordinate of the start point of the cubic curve segment.

  ### Properties declared in class javafx.scene.shape.Shape

  `fill, smooth, strokeDashOffset, strokeLineCap, strokeLineJoin, strokeMiterLimit, stroke, strokeType, strokeWidth`

  ### Properties declared in class javafx.scene.Node

  `accessibleHelp, accessibleRoleDescription, accessibleRole, accessibleText, blendMode, boundsInLocal, boundsInParent, cacheHint, cache, clip, cursor, depthTest, disabled, disable, effectiveNodeOrientation, effect, eventDispatcher, focused, focusTraversable, hover, id, inputMethodRequests, layoutBounds, layoutX, layoutY, localToParentTransform, localToSceneTransform, managed, mouseTransparent, nodeOrientation, onContextMenuRequested, onDragDetected, onDragDone, onDragDropped, onDragEntered, onDragExited, onDragOver, onInputMethodTextChanged, onKeyPressed, onKeyReleased, onKeyTyped, onMouseClicked, onMouseDragEntered, onMouseDragExited, onMouseDragged, onMouseDragOver, onMouseDragReleased, onMouseEntered, onMouseExited, onMouseMoved, onMousePressed, onMouseReleased, onRotate, onRotationFinished, onRotationStarted, onScrollFinished, onScroll, onScrollStarted, onSwipeDown, onSwipeLeft, onSwipeRight, onSwipeUp, onTouchMoved, onTouchPressed, onTouchReleased, onTouchStationary, onZoomFinished, onZoom, onZoomStarted, opacity, parent, pickOnBounds, pressed, rotate, rotationAxis, scaleX, scaleY, scaleZ, scene, style, translateX, translateY, translateZ, viewOrder, visible`

- ## Field Summary

  ### Fields declared in class javafx.scene.Node

  `BASELINE_OFFSET_SAME_AS_HEIGHT`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `CubicCurve()`
  Creates an empty instance of CubicCurve.
  `CubicCurve(double startX, double startY, double controlX1, double controlY1, double controlX2, double controlY2, double endX, double endY)`
  Creates a new instance of CubicCurve.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `final DoubleProperty`
  `controlX1Property()`
  Defines the X coordinate of the first control point of the cubic curve segment.
  `final DoubleProperty`
  `controlX2Property()`
  Defines the X coordinate of the second control point of the cubic curve segment.
  `final DoubleProperty`
  `controlY1Property()`
  Defines the Y coordinate of the first control point of the cubic curve segment.
  `final DoubleProperty`
  `controlY2Property()`
  Defines the Y coordinate of the second control point of the cubic curve segment.
  `final DoubleProperty`
  `endXProperty()`
  Defines the X coordinate of the end point of the cubic curve segment.
  `final DoubleProperty`
  `endYProperty()`
  Defines the Y coordinate of the end point of the cubic curve segment.
  `final double`
  `getControlX1()`
  Gets the value of the property controlX1.
  `final double`
  `getControlX2()`
  Gets the value of the property controlX2.
  `final double`
  `getControlY1()`
  Gets the value of the property controlY1.
  `final double`
  `getControlY2()`
  Gets the value of the property controlY2.
  `final double`
  `getEndX()`
  Gets the value of the property endX.
  `final double`
  `getEndY()`
  Gets the value of the property endY.
  `final double`
  `getStartX()`
  Gets the value of the property startX.
  `final double`
  `getStartY()`
  Gets the value of the property startY.
  `final void`
  `setControlX1(double value)`
  Sets the value of the property controlX1.
  `final void`
  `setControlX2(double value)`
  Sets the value of the property controlX2.
  `final void`
  `setControlY1(double value)`
  Sets the value of the property controlY1.
  `final void`
  `setControlY2(double value)`
  Sets the value of the property controlY2.
  `final void`
  `setEndX(double value)`
  Sets the value of the property endX.
  `final void`
  `setEndY(double value)`
  Sets the value of the property endY.
  `final void`
  `setStartX(double value)`
  Sets the value of the property startX.
  `final void`
  `setStartY(double value)`
  Sets the value of the property startY.
  `final DoubleProperty`
  `startXProperty()`
  Defines the X coordinate of the start point of the cubic curve segment.
  `final DoubleProperty`
  `startYProperty()`
  Defines the Y coordinate of the start point of the cubic curve segment.
  `String`
  `toString()`
  Returns a string representation of this `CubicCurve` object.

  ### Methods declared in class javafx.scene.shape.Shape

  `fillProperty, getClassCssMetaData, getCssMetaData, getFill, getStroke, getStrokeDashArray, getStrokeDashOffset, getStrokeLineCap, getStrokeLineJoin, getStrokeMiterLimit, getStrokeType, getStrokeWidth, intersect, isSmooth, setFill, setSmooth, setStroke, setStrokeDashOffset, setStrokeLineCap, setStrokeLineJoin, setStrokeMiterLimit, setStrokeType, setStrokeWidth, smoothProperty, strokeDashOffsetProperty, strokeLineCapProperty, strokeLineJoinProperty, strokeMiterLimitProperty, strokeProperty, strokeTypeProperty, strokeWidthProperty, subtract, union`

  ### Methods declared in class javafx.scene.Node

  `accessibleHelpProperty, accessibleRoleDescriptionProperty, accessibleRoleProperty, accessibleTextProperty, addEventFilter, addEventHandler, applyCss, autosize, blendModeProperty, boundsInLocalProperty, boundsInParentProperty, buildEventDispatchChain, cacheHintProperty, cacheProperty, clipProperty, computeAreaInScreen, contains, contains, cursorProperty, depthTestProperty, disabledProperty, disableProperty, effectiveNodeOrientationProperty, effectProperty, eventDispatcherProperty, executeAccessibleAction, fireEvent, focusedProperty, focusTraversableProperty, getAccessibleHelp, getAccessibleRole, getAccessibleRoleDescription, getAccessibleText, getBaselineOffset, getBlendMode, getBoundsInLocal, getBoundsInParent, getCacheHint, getClip, getContentBias, getCursor, getDepthTest, getEffect, getEffectiveNodeOrientation, getEventDispatcher, getId, getInitialCursor, getInitialFocusTraversable, getInputMethodRequests, getLayoutBounds, getLayoutX, getLayoutY, getLocalToParentTransform, getLocalToSceneTransform, getNodeOrientation, getOnContextMenuRequested, getOnDragDetected, getOnDragDone, getOnDragDropped, getOnDragEntered, getOnDragExited, getOnDragOver, getOnInputMethodTextChanged, getOnKeyPressed, getOnKeyReleased, getOnKeyTyped, getOnMouseClicked, getOnMouseDragEntered, getOnMouseDragExited, getOnMouseDragged, getOnMouseDragOver, getOnMouseDragReleased, getOnMouseEntered, getOnMouseExited, getOnMouseMoved, getOnMousePressed, getOnMouseReleased, getOnRotate, getOnRotationFinished, getOnRotationStarted, getOnScroll, getOnScrollFinished, getOnScrollStarted, getOnSwipeDown, getOnSwipeLeft, getOnSwipeRight, getOnSwipeUp, getOnTouchMoved, getOnTouchPressed, getOnTouchReleased, getOnTouchStationary, getOnZoom, getOnZoomFinished, getOnZoomStarted, getOpacity, getParent, getProperties, getPseudoClassStates, getRotate, getRotationAxis, getScaleX, getScaleY, getScaleZ, getScene, getStyle, getStyleableParent, getStyleClass, getTransforms, getTranslateX, getTranslateY, getTranslateZ, getTypeSelector, getUserData, getViewOrder, hasProperties, hoverProperty, idProperty, inputMethodRequestsProperty, intersects, intersects, isCache, isDisable, isDisabled, isFocused, isFocusTraversable, isHover, isManaged, isMouseTransparent, isPickOnBounds, isPressed, isResizable, isVisible, layoutBoundsProperty, layoutXProperty, layoutYProperty, localToParent, localToParent, localToParent, localToParent, localToParent, localToParentTransformProperty, localToScene, localToScene, localToScene, localToScene, localToScene, localToScene, localToScene, localToScene, localToScene, localToScene, localToSceneTransformProperty, localToScreen, localToScreen, localToScreen, localToScreen, localToScreen, lookup, lookupAll, managedProperty, maxHeight, maxWidth, minHeight, minWidth, mouseTransparentProperty, nodeOrientationProperty, notifyAccessibleAttributeChanged, onContextMenuRequestedProperty, onDragDetectedProperty, onDragDoneProperty, onDragDroppedProperty, onDragEnteredProperty, onDragExitedProperty, onDragOverProperty, onInputMethodTextChangedProperty, onKeyPressedProperty, onKeyReleasedProperty, onKeyTypedProperty, onMouseClickedProperty, onMouseDragEnteredProperty, onMouseDragExitedProperty, onMouseDraggedProperty, onMouseDragOverProperty, onMouseDragReleasedProperty, onMouseEnteredProperty, onMouseExitedProperty, onMouseMovedProperty, onMousePressedProperty, onMouseReleasedProperty, onRotateProperty, onRotationFinishedProperty, onRotationStartedProperty, onScrollFinishedProperty, onScrollProperty, onScrollStartedProperty, onSwipeDownProperty, onSwipeLeftProperty, onSwipeRightProperty, onSwipeUpProperty, onTouchMovedProperty, onTouchPressedProperty, onTouchReleasedProperty, onTouchStationaryProperty, onZoomFinishedProperty, onZoomProperty, onZoomStartedProperty, opacityProperty, parentProperty, parentToLocal, parentToLocal, parentToLocal, parentToLocal, parentToLocal, pickOnBoundsProperty, prefHeight, prefWidth, pressedProperty, pseudoClassStateChanged, queryAccessibleAttribute, relocate, removeEventFilter, removeEventHandler, requestFocus, resize, resizeRelocate, rotateProperty, rotationAxisProperty, scaleXProperty, scaleYProperty, scaleZProperty, sceneProperty, sceneToLocal, sceneToLocal, sceneToLocal, sceneToLocal, sceneToLocal, sceneToLocal, sceneToLocal, sceneToLocal, screenToLocal, screenToLocal, screenToLocal, setAccessibleHelp, setAccessibleRole, setAccessibleRoleDescription, setAccessibleText, setBlendMode, setCache, setCacheHint, setClip, setCursor, setDepthTest, setDisable, setDisabled, setEffect, setEventDispatcher, setEventHandler, setFocused, setFocusTraversable, setHover, setId, setInputMethodRequests, setLayoutX, setLayoutY, setManaged, setMouseTransparent, setNodeOrientation, setOnContextMenuRequested, setOnDragDetected, setOnDragDone, setOnDragDropped, setOnDragEntered, setOnDragExited, setOnDragOver, setOnInputMethodTextChanged, setOnKeyPressed, setOnKeyReleased, setOnKeyTyped, setOnMouseClicked, setOnMouseDragEntered, setOnMouseDragExited, setOnMouseDragged, setOnMouseDragOver, setOnMouseDragReleased, setOnMouseEntered, setOnMouseExited, setOnMouseMoved, setOnMousePressed, setOnMouseReleased, setOnRotate, setOnRotationFinished, setOnRotationStarted, setOnScroll, setOnScrollFinished, setOnScrollStarted, setOnSwipeDown, setOnSwipeLeft, setOnSwipeRight, setOnSwipeUp, setOnTouchMoved, setOnTouchPressed, setOnTouchReleased, setOnTouchStationary, setOnZoom, setOnZoomFinished, setOnZoomStarted, setOpacity, setPickOnBounds, setPressed, setRotate, setRotationAxis, setScaleX, setScaleY, setScaleZ, setStyle, setTranslateX, setTranslateY, setTranslateZ, setUserData, setViewOrder, setVisible, snapshot, snapshot, startDragAndDrop, startFullDrag, styleProperty, toBack, toFront, translateXProperty, translateYProperty, translateZProperty, usesMirroring, viewOrderProperty, visibleProperty`

  ### Methods declared in class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

  ### Methods declared in interface javafx.css.Styleable

  `getStyleableNode`

- ## Property Details

  - ### startX

    public final DoubleProperty startXProperty
    Defines the X coordinate of the start point of the cubic curve segment.
    Default value:
      0.0
    See Also:
      - `getStartX()`
      - `setStartX(double)`

  - ### startY

    public final DoubleProperty startYProperty
    Defines the Y coordinate of the start point of the cubic curve segment.
    Default value:
      0.0
    See Also:
      - `getStartY()`
      - `setStartY(double)`

  - ### controlX1

    public final DoubleProperty controlX1Property
    Defines the X coordinate of the first control point of the cubic curve segment.
    Default value:
      0.0
    See Also:
      - `getControlX1()`
      - `setControlX1(double)`

  - ### controlY1

    public final DoubleProperty controlY1Property
    Defines the Y coordinate of the first control point of the cubic curve segment.
    Default value:
      0.0
    See Also:
      - `getControlY1()`
      - `setControlY1(double)`

  - ### controlX2

    public final DoubleProperty controlX2Property
    Defines the X coordinate of the second control point of the cubic curve segment.
    Default value:
      0.0
    See Also:
      - `getControlX2()`
      - `setControlX2(double)`

  - ### controlY2

    public final DoubleProperty controlY2Property
    Defines the Y coordinate of the second control point of the cubic curve segment.
    Default value:
      0.0
    See Also:
      - `getControlY2()`
      - `setControlY2(double)`

  - ### endX

    public final DoubleProperty endXProperty
    Defines the X coordinate of the end point of the cubic curve segment.
    Default value:
      0.0
    See Also:
      - `getEndX()`
      - `setEndX(double)`

  - ### endY

    public final DoubleProperty endYProperty
    Defines the Y coordinate of the end point of the cubic curve segment.
    Default value:
      0.0
    See Also:
      - `getEndY()`
      - `setEndY(double)`

- ## Constructor Details

  - ### CubicCurve

    public CubicCurve()
    Creates an empty instance of CubicCurve.

  - ### CubicCurve

    public CubicCurve(double startX, double startY, double controlX1, double controlY1, double controlX2, double controlY2, double endX, double endY)
    Creates a new instance of CubicCurve.
    Parameters:
      `startX` - the X coordinate of the start point
      `startY` - the Y coordinate of the start point
      `controlX1` - the X coordinate of the first control point
      `controlY1` - the Y coordinate of the first control point
      `controlX2` - the X coordinate of the second control point
      `controlY2` - the Y coordinate of the second control point
      `endX` - the X coordinate of the end point
      `endY` - the Y coordinate of the end point
    Since:
      JavaFX 2.1

- ## Method Details

  - ### setStartX

    public final void setStartX(double value)
    Sets the value of the property startX.
    Property description:
      Defines the X coordinate of the start point of the cubic curve segment.
    Default value:
      0.0

  - ### getStartX

    public final double getStartX()
    Gets the value of the property startX.
    Property description:
      Defines the X coordinate of the start point of the cubic curve segment.
    Default value:
      0.0

  - ### startXProperty

    public final DoubleProperty startXProperty()
    Defines the X coordinate of the start point of the cubic curve segment.
    Default value:
      0.0
    See Also:
      - `getStartX()`
      - `setStartX(double)`

  - ### setStartY

    public final void setStartY(double value)
    Sets the value of the property startY.
    Property description:
      Defines the Y coordinate of the start point of the cubic curve segment.
    Default value:
      0.0

  - ### getStartY

    public final double getStartY()
    Gets the value of the property startY.
    Property description:
      Defines the Y coordinate of the start point of the cubic curve segment.
    Default value:
      0.0

  - ### startYProperty

    public final DoubleProperty startYProperty()
    Defines the Y coordinate of the start point of the cubic curve segment.
    Default value:
      0.0
    See Also:
      - `getStartY()`
      - `setStartY(double)`

  - ### setControlX1

    public final void setControlX1(double value)
    Sets the value of the property controlX1.
    Property description:
      Defines the X coordinate of the first control point of the cubic curve segment.
    Default value:
      0.0

  - ### getControlX1

    public final double getControlX1()
    Gets the value of the property controlX1.
    Property description:
      Defines the X coordinate of the first control point of the cubic curve segment.
    Default value:
      0.0

  - ### controlX1Property

    public final DoubleProperty controlX1Property()
    Defines the X coordinate of the first control point of the cubic curve segment.
    Default value:
      0.0
    See Also:
      - `getControlX1()`
      - `setControlX1(double)`

  - ### setControlY1

    public final void setControlY1(double value)
    Sets the value of the property controlY1.
    Property description:
      Defines the Y coordinate of the first control point of the cubic curve segment.
    Default value:
      0.0

  - ### getControlY1

    public final double getControlY1()
    Gets the value of the property controlY1.
    Property description:
      Defines the Y coordinate of the first control point of the cubic curve segment.
    Default value:
      0.0

  - ### controlY1Property

    public final DoubleProperty controlY1Property()
    Defines the Y coordinate of the first control point of the cubic curve segment.
    Default value:
      0.0
    See Also:
      - `getControlY1()`
      - `setControlY1(double)`

  - ### setControlX2

    public final void setControlX2(double value)
    Sets the value of the property controlX2.
    Property description:
      Defines the X coordinate of the second control point of the cubic curve segment.
    Default value:
      0.0

  - ### getControlX2

    public final double getControlX2()
    Gets the value of the property controlX2.
    Property description:
      Defines the X coordinate of the second control point of the cubic curve segment.
    Default value:
      0.0

  - ### controlX2Property

    public final DoubleProperty controlX2Property()
    Defines the X coordinate of the second control point of the cubic curve segment.
    Default value:
      0.0
    See Also:
      - `getControlX2()`
      - `setControlX2(double)`

  - ### setControlY2

    public final void setControlY2(double value)
    Sets the value of the property controlY2.
    Property description:
      Defines the Y coordinate of the second control point of the cubic curve segment.
    Default value:
      0.0

  - ### getControlY2

    public final double getControlY2()
    Gets the value of the property controlY2.
    Property description:
      Defines the Y coordinate of the second control point of the cubic curve segment.
    Default value:
      0.0

  - ### controlY2Property

    public final DoubleProperty controlY2Property()
    Defines the Y coordinate of the second control point of the cubic curve segment.
    Default value:
      0.0
    See Also:
      - `getControlY2()`
      - `setControlY2(double)`

  - ### setEndX

    public final void setEndX(double value)
    Sets the value of the property endX.
    Property description:
      Defines the X coordinate of the end point of the cubic curve segment.
    Default value:
      0.0

  - ### getEndX

    public final double getEndX()
    Gets the value of the property endX.
    Property description:
      Defines the X coordinate of the end point of the cubic curve segment.
    Default value:
      0.0

  - ### endXProperty

    public final DoubleProperty endXProperty()
    Defines the X coordinate of the end point of the cubic curve segment.
    Default value:
      0.0
    See Also:
      - `getEndX()`
      - `setEndX(double)`

  - ### setEndY

    public final void setEndY(double value)
    Sets the value of the property endY.
    Property description:
      Defines the Y coordinate of the end point of the cubic curve segment.
    Default value:
      0.0

  - ### getEndY

    public final double getEndY()
    Gets the value of the property endY.
    Property description:
      Defines the Y coordinate of the end point of the cubic curve segment.
    Default value:
      0.0

  - ### endYProperty

    public final DoubleProperty endYProperty()
    Defines the Y coordinate of the end point of the cubic curve segment.
    Default value:
      0.0
    See Also:
      - `getEndY()`
      - `setEndY(double)`

  - ### toString

    public String toString()
    Returns a string representation of this `CubicCurve` object.
    Overrides:
      `toString` in class `Node`
    Returns:
      a string representation of this `CubicCurve` object.